#
# Conditional build:
%bcond_without	javadoc		# don't build javadoc

%define		srcname		bcel
%include	/usr/lib/rpm/macros.java
Summary:	Byte Code Engineering Library
Summary(pl.UTF-8):	Biblioteka do obróbki bajtkodu Javy
Name:		java-bcel
Version:	5.2
Release:	3
License:	Apache v2.0
Group:		Libraries/Java
Source0:	http://www.apache.org/dist/jakarta/bcel/source/%{srcname}-%{version}-src.tar.gz
# Source0-md5:	905b7e718e30e7ca726530ecf106e532
Patch0:		jakarta-%{srcname}-manifest.patch
Patch1:		%{name}-noproxy.patch
URL:		http://jakarta.apache.org/bcel/
BuildRequires:	ant
BuildRequires:	java-regexp >= 1.2
BuildRequires:	jdk
BuildRequires:	jpackage-utils
BuildRequires:	rpm-javaprov
BuildRequires:	rpmbuild(macros) >= 1.300
BuildRequires:	unzip
Requires:	java-regexp >= 1.2
Obsoletes:	jakarta-bcel
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The Byte Code Engineering Library (formerly known as JavaClass) is
intended to give users a convenient possibility to analyze, create,
and manipulate (binary) Java class files (those ending with .class).
Classes are represented by objects which contain all the symbolic
information of the given class: methods, fields and byte code
instructions, in particular. Such objects can be read from an existing
file, be transformed by a program (e.g. a class loader at run-time)
and dumped to a file again. An even more interesting application is
the creation of classes from scratch at run-time. The Byte Code
Engineering Library (BCEL) may be also useful if you want to learn
about the Java Virtual Machine (JVM) and the format of Java .class
files. BCEL is already being used successfully in several projects
such as compilers, optimizers, obsfuscators and analysis tools, the
most popular probably being the Xalan XSLT processor at Apache.

%description -l pl.UTF-8
BCEL (Byte Code Engineering Library, poprzednio znana jako JavaClass)
ma umożliwić wygodne analizowanie, tworzenie i obróbkę (binarnych)
plików klas Javy (tych z nazwą kończącą się na .class). Klasy są
reprezentowane przez obiekty zawierające wszystkie symboliczne
informacje o danej klasie, w szczególności metody, pola i instrukcje
bajtkodu. Obiekty te mogą być odczytywane z istniejącego pliku,
przekształcane przez program (np. wczytujący klasy w czasie działania)
i zrzucane z powrotem do pliku. Jeszcze ciekawszym zastosowaniem jest
tworzenie klas od zera w czasie działania programu. Biblioteka BCEL
może być także użyteczna, jeśli chcemy nauczyć się czegoś o maszynie
wirtualnej Javy (JVM) oraz formacie plików .class. BCEL jest używana z
sukcesem w różnych projektach, takich jak kompilatory, optymalizatory,
narzędzia utrudniające analizę oraz narzędzia do analizy, z których
najpopularniejszym jest procesor XSLT Xalan.

%package javadoc
Summary:	Byte Code Engineering Library documentation
Summary(pl.UTF-8):	Dokumentacja do biblioteki do obróbki bajtkodu Javy
Group:		Documentation
Requires:	jpackage-utils
Obsoletes:	jakarta-bcel-doc
Obsoletes:	jakarta-bcel-javadoc

%description javadoc
Byte Code Engineering Library documentation.

%description javadoc -l pl.UTF-8
Dokumentacja do biblioteki do obróbki bajtkodu Javy.

%prep
%setup -q -n bcel-%{version}
%patch0 -p1
%patch1 -p1
find -name '*.jar' | xargs rm -f

%build
CLASSPATH="$(build-classpath regexp)"
export JAVA_HOME="%{java_home}"
export LC_ALL=en_US

%ant jar %{?with_javadoc:javadoc} \
	-Dnoget=1

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_javadir}

cp -p target/%{srcname}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{srcname}-%{version}.jar
ln -sf %{srcname}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{srcname}.jar

%if %{with javadoc}
install -d $RPM_BUILD_ROOT%{_javadocdir}/%{srcname}-%{version}
cp -R dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{srcname}-%{version}
ln -s %{srcname}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{srcname} # ghost symlink
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
ln -nfs %{srcname}-%{version} %{_javadocdir}/%{srcname}

%files
%defattr(644,root,root,755)
%doc LICENSE.txt
%{_javadir}/bcel-%{version}.jar
%{_javadir}/bcel.jar

%if %{with javadoc}
%files javadoc
%defattr(644,root,root,755)
%{_javadocdir}/%{srcname}-%{version}
%ghost %{_javadocdir}/%{srcname}
%endif
%changelog
* Wed Sep 04 2019 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/java-bcel.git;a=log;h=master

* Wed Sep 04 2019 Marcin Krol <hawk@tld-linux.org> 608756b
- release 3

* Sat Feb 01 2014 Elan Ruusamäe <glen@delfi.ee> 64bbf3f
- avoid self-obsoletes; drop old jakarta provides

* Thu Feb 10 2011 Jakub Bogusz <qboosh@pld-linux.org> 68ed154
- updated to 5.2
- removed obsolete build,jdk15 patches, added noproxy patch

* Sun Apr 18 2010 pawelz <pawelz@pld-linux.org> 4eeb7b8
- don't force gcj for th
- typo in G:

* Thu Oct 22 2009 pawelz <pawelz@pld-linux.org> d36b8a1
- export LC_ALL=en_US. Otherwise ant apidocs generation fails with gcj.

* Mon Apr 13 2009 Elan Ruusamäe <glen@pld-linux.org> 22bb974
- xargs for less exec calls

* Mon Apr 13 2009 Elan Ruusamäe <glen@pld-linux.org> 201eb30
- bcond header

* Mon Apr 13 2009 pawelz <pawelz@pld-linux.org> 6339323
- javadoc bcond
- unify java package
- added two lines to last commit log

* Mon Apr 13 2009 pawelz <pawelz@pld-linux.org> 4aa5eb8
- renamed to java-bcel
- jdk bconds
- include java rpm macros
- allow build-classpath to die and break build process

* Tue Feb 13 2007 Elan Ruusamäe <glen@pld-linux.org> 41df4ec
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> dd9687a
- converted to UTF-8

* Fri Dec 08 2006 Elan Ruusamäe <glen@pld-linux.org> c6aa2e5
- -javadoc R: jpackage-utils for parent dirs; rel 2

* Wed May 24 2006 Jakub Bogusz <qboosh@pld-linux.org> 748d3c2
- Obsoletes for jakarta-bcel-doc

* Wed May 24 2006 Jacek Konieczny <jajcus@pld-linux.org> 3845931
- BR: jpackage-utils, rpmbuild(macros) >= 1.300
- P: bcel
- ExclusiveArch for builders with JDK
- API docs installed in %{_javadocdir} and packaged into -javadoc subpackage

* Fri May 19 2006 Jacek Konieczny <jajcus@pld-linux.org> 067fd00
- s/jakarta-ant/ant/ in BR

* Sat May 07 2005 Jakub Bogusz <qboosh@pld-linux.org> 4f54490
- updated Source0 URL (but use .zip as current .tar.gz contains a lot of junk)
- added jdk15 patch needed to build using jdk 1.5
- pl unifications

* Sat May 07 2005 Jakub Bogusz <qboosh@pld-linux.org> 11aa6e4
- allow build with jdk 1.5 (from bcel svn)

* Thu Jul 15 2004 Paweł Sikora <pluto@pld-linux.org> 4bea712
- use %{_javadir}.
- release 1.

* Mon Aug 11 2003 ankry <ankry@pld-linux.org> ecd2972
- cosmetics

* Thu Jul 03 2003 Jakub Bogusz <qboosh@pld-linux.org> 93b0297
- separated -doc (over 20 times larger than base package)

